%import diskio

%zeropage basicsafe
%option no_sysinit

main {

    uword default_irq

    sub start() { 
        
        stream_audio()
        repeat {}
    }

    sub stream_audio()
    {
        default_irq = cx16.CINV

        diskio.f_open("intro.pcm")

        sys.set_irqd()
        cx16.VERA_AUDIO_CTRL = %10101111
        cx16.VERA_AUDIO_RATE = 32
        cx16.CINV = &irq_handler
        cx16.VERA_IEN = %00001001
        sys.clear_irqd()
    }

    sub stream_stop()
    {
        diskio.f_close()
        sys.set_irqd()
        cx16.CINV = default_irq
        cx16.VERA_IEN = %00000001
        cx16.VERA_AUDIO_RATE = 0
        sys.clear_irqd()
    }

    sub irq_handler() 
    {
        if cx16.VERA_ISR & %00001000 
        {
            load_audio()
        }
        goto default_irq
    }

    sub load_audio()
    {
        uword size
        uword num_bytes = 1024*2

        while num_bytes {
            if num_bytes < 255
                size = num_bytes
            size = cx16.macptr(lsb(size), &cx16.VERA_AUDIO_DATA, true)
            num_bytes -= size

            if cbm.READST() & $40 {
                stream_stop()
                break
            }
        }
    }
}